#!/usr/bin/perl
# Change the line above the reflect the path to Perl.

# TODO: multiple users
# TODO: ban IPs

use strict;
use CGI;

###############
## VARIABLES ####################################################
###############

my $VARFILE = 'vars.dat';

my $TPVERSION = '2.2 Beta';
my %TPVARS = ();
my $VARSEP = '``z';
my $QUERY = $ENV{'QUERY_STRING'};

my %Cookies = ();
my $cookieExpLength = 259200; # Lifespan of cookies, in seconds. 259200 seconds is equal to 30 days.

my @Abbrev_Week_Days = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
my @Abbrev_Months = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

my $q = new CGI;
my $header_printed = 0;

##########
## MAIN #########################################################
##########

load_vars();
check_first_time();
check_login();
core();
exit;

##########
## CORE #########################################################
##########

sub core {

	my $action = $q->param('action');
   
	if($action) {
   
		if	  ($action eq 'tags')			{ do_tags(); }
		elsif($action eq 'settings')		{ do_settings(); }
		elsif($action eq 'admin')			{ do_admin(); }
		elsif($action eq 'messages')		{ do_messages(); }
		elsif($action eq 'msg_defaults') { do_msg_defaults(); }
		else { error_msg('Invalid action.'); }
   
	} else {

		if	  ($QUERY eq 'menu' || $QUERY eq '')  { print_main_page(); }
		elsif($QUERY eq 'menu-tags')				  { print_tags_page(); }
		elsif($QUERY eq 'menu-settings')			  { print_settings_page(); }
		elsif($QUERY eq 'menu-admin')				  { print_admin_page(); }
		elsif($QUERY eq 'menu-messages')			  { print_messages_page(); }
		elsif($QUERY eq 'menu-logout')			  { logout(); }
		else { error_msg('Invalid query.'); }

	}

}

#########################
## DATA/VARS FUNCTIONS ##########################################
#########################

sub load_vars {

	open VARS, $VARFILE or error_msg('Could not open data file.');
	my @vars = <VARS>;
	close VARS;
   
	my $varname;
	my $varvalue;
   
	for (@vars) {
		chomp;
		($varname, $varvalue) = split /$VARSEP/;
		$TPVARS{$varname} = $varvalue;
	}

}

########

sub save_vars {

	open VARS, ">$VARFILE" or error_msg('Could not open data file.');

	my $key;

	foreach $key (keys %TPVARS) {
		print VARS "$key$VARSEP$TPVARS{$key}\n";
	}

	close VARS;
}

#############################
## LOGIN/STARTUP FUNCTIONS ######################################
#############################

sub check_first_time {

	if($TPVARS{'first_time'}) {
		my $un = $q->param('un');
		my $pw = $q->param('pw');
		if($un && $pw) {
			$TPVARS{'admin_uname'} = $un;
			$TPVARS{'admin_pword'} = $pw;
			$TPVARS{'first_time'} = 0;
			save_vars();
			SetCookies('uname',$un,'pword',$pw);
			print_main_page();
		} else {
			print_install_page();
		}
	}	 

}

########

sub check_login {
	   
	# TODO: use crypt() on passwords

	GetCookies();

	if($Cookies{'uname'} ne $TPVARS{'admin_uname'} || $Cookies{'pword'} ne $TPVARS{'admin_pword'}) {

		if($q->param('action') eq 'login') {

			my $un = $q->param('un');
			my $pw = $q->param('pw');
	   
			if($un eq $TPVARS{'admin_uname'} && $pw eq $TPVARS{'admin_pword'}) {
				SetCookies('uname',$un,'pword',$pw);
				print_main_page();
			} else {
				error_msg('Invalid username/password.');
			}

		} else {

			print_login_page();

		}
	}

}

########

sub logout() {

	ClearCookies();
	message('Logged Out', 'You are now logged out.')

}

###########################
## OUTPUT/HTML FUNCTIONS ########################################
###########################

sub print_header {

	unless($header_printed) {
		print $q->header;
		$header_printed = 1;
	}

}

########

sub print_admin_header {

	my $title = shift;
	print_header();
	print <<"EOF";
<html>
	<head>
		<title>TagPro: $title</title>
		<style type="text/css">
			A:link,	A:visited { text-decoration: underline; color: #0000aa; }
			A:hover, A:active	 { text-decoration: none; color: #0066FF; }
			small { font-size: 7pt; }
			big { font-size: 11pt; font-weight: bold; }
			body, td, input, textarea	{
				color: #000000;
				font-family: Arial, Verdana;
				font-size: 10pt;
			}
			.navbar { font-size: 9pt; }
		</style>
	</head>
	<body bgcolor="#6699CC">
		<table cellpadding="5" cellspacing="0" border="1" bordercolor="#666666" width="50%" align="center"><tr><td bgcolor="#99CCFF" align="center">
			<big>TagPro: $title</big>
		</td></tr></table>
		<p>
		<table cellpadding="5" cellspacing="0" border="1" bordercolor="#666666" width="70%" align="center"><tr><td bgcolor="#99CCFF">
EOF

}

########

sub print_admin_footer {

	print <<"EOF";
		</td></tr></table>
		<p>
		<table cellpadding="5" cellspacing="0" border="1" bordercolor="#666666" width="50%" align="center"><tr><td bgcolor="#99CCFF" align="center" class="navbar">
			<a href="?menu">Main Menu</a> | <a href="?menu-tags">Modify Tags</a> | <a href="?menu-settings">Change Settings</a>
			<br><a href="?menu-admin">Admin Settings</a> | <a href="?menu-messages">Messages</a> | <a href="?menu-logout">Log Out</a>
		</td></tr></table>
		<p><br><div align="center"><small>TagPro Version $TPVERSION</small></div>
	</body>
</html>
EOF

}

###########
## PAGES ########################################################
###########

sub print_main_page {

	print_admin_header('Main Menu');
	print <<"EOF";
				<a href="?menu-tags">Modify Tags</a>: Delete or modify posts on the tag board.
				<br><br><a href="?menu-settings">Change Settings</a>: Change general preferences and system settings.
				<br><br><a href="?menu-admin">Admin Settings</a>: Change the admin username or password.
				<br><br><a href="?menu-messages">Messages</a>: Edit the messages displayed to the visitor, including error messages.
				<br><br><a href="?menu-logout">Log Out</a>: Logs you out of the system, so that you cannot access this menu until you log in again.
				<small>
					<p>Your version: $TPVERSION
   				<br>Current version: <img src="http://www.danlewis.org/tagpro/curver.cgi" border="0">
   				<br>If the current version is higher than your version, click <a href="http://www.danlewis.org/tagpro">here</a> to update.
				</small>
EOF
	print_admin_footer();

	exit;

}

########

sub print_tags_page {

	open IN, $TPVARS{'tag_dat'} or error_msg('Cannot open the tag board data file. The path to the file can be changed in the <a href="?menu-settings">Settings</a>. The file may not exist yet if there there are no tags on the tagboard.');
	my @tags = <IN>;
	close IN;

	print_admin_header('Modify Tags');

	my ($num, $time, $ip, $name, $url, $msg, $date);
	my ($Second, $Minute, $Hour, $Month_Day, $Month, $Year, $Week_Day, $IsDST, $AMPM);

	if($#tags != -1) {

		$num = $#tags + 1;

		print "\t\t\t<b>Number of tags: $num</b>\n";
		print "\t\t\t<form method=\"POST\"><input type=\"hidden\" name=\"num\" value=\"$#tags\"><input type=\"hidden\" name=\"action\" value=\"tags\">\n";
		for(@tags) {

			chomp;
			($num, $time, $ip, $name, $url, $msg) = split /<>/;

			($Second, $Minute, $Hour, $Month_Day, $Month, $Year, $Week_Day, $IsDST) = (localtime($time))[0,1,2,3,4,5,6,8]; 
			$Month_Day = "0$Month_Day" if ($Month_Day < 10);
			$Minute = "0$Minute" if ($Minute < 10);
			$Second = "0$Second" if ($Second < 10);
			$Year = $Year + 1900;
			$AMPM = ($Hour < 12) ? "AM" : "PM";

			$date = "$Abbrev_Week_Days[$Week_Day], $Month_Day-$Abbrev_Months[$Month]-$Year $Hour:$Minute:$Second $AMPM";
	   
			print <<"EOF";
				<hr size="1" noshade>
				<table cellpadding="0" cellspacing="0" border="0">
					<tr><td>Date:</td><td>$date<input type="hidden" name="time$num" value="$time"></td></tr>
					<tr><td>IP:</td><td>$ip<input type="hidden" name="ip$num" value="$ip"></td></tr>
					<tr><td>Name:</td><td><input type="text" name="name$num" value="$name" size="35"></td></tr>
					<tr><td>URL:</td><td><input type="text" name="url$num" value="$url" size="35"></td></tr>
					<tr><td>Message:</td><td><input type="text" name="msg$num" value="$msg" size="35"></td></tr>
					<tr><td colspan="2" align="center">Save<input type="radio" name="keep$num" value="1" checked> &nbsp; Delete<input type="radio" name="keep$num" value="0"></td></tr>
				</table>		   
EOF

		}

		print "\t\t\t\t<p align=\"center\"><input type=\"submit\" value=\" Submit Changes \">\n";
		print "\t\t\t</form>\n";
   
	} else {
		print "The tag board is empty.";
	}

	print_admin_footer();

	exit;

}

########

sub print_settings_page {

	print_admin_header('Change Settings');
	my $op_on = ''; my $op_off = '';
	if($TPVARS{'auto_redirect'}) { $op_on = ' selected'; } else { $op_off = ' selected'; }
	print <<"EOF";
			<form method="POST"><input type="hidden" name="action" value="settings">
				<big>Preferences</big>
				<p><b>Maximum Tags</b>
				<br>Maximum number of tags allowed on the tag board. After this number is reached, the old tags will be deleted as new ones are added.<br>
				<input type="text" name="max_tags" value="$TPVARS{'max_tags'}">
				<br><br><b>Separator</b>
				<br>The separator between the name and message.<br>
				<input type="text" name="separator" value="$TPVARS{'separator'}">
				<br><br><b>Maximum Content Size</b>
				<br>Maximum size (in characters) of the name, URL, and message combined.<br>
				<input type="text" name="max_content_size" value="$TPVARS{'max_content_size'}">
				<br><br><b>Max Word Size</b>
				<br>The maximum number of characters allowed in a single "word".<br>
				<input type="text" name="word_max_chars" value="$TPVARS{'word_max_chars'}">
				<br><br><b>Tag Time Limit</b>
				<br>The time in seconds that a visitor (based on IP address) must wait in order to tag again.<br>
				<input type="text" name="time_limit" value="$TPVARS{'time_limit'}">
				<br><br><b>Auto Redirect</b>
				<br>Auto Redirect will bypass the message displayed when a tag is successfully posted, and will automatically return to the return URL.<br>
				<select name="auto_redirect"><option$op_off value="0">Auto Redirect OFF</option><option$op_on value="1">Auto Redirect ON</option></select>
				<br><br><b>Vulgarity</b>
				<br>The following list of words will not be allowed to be posted on the tag board. Separate multiple words by a single space.<br>
				<input type="text" name="bad_words" value="$TPVARS{'bad_words'}" size="35">
				<p><br><big>System Settings</big>
				<p><b>Tag Board Path</b>
				<br>The path to the tag board file. This is the file that is included into your website.<br>
				<input type="text" name="tag_path" value="$TPVARS{'tag_path'}" size="35">
				<p><b>Tag Data Path</b>
				<br>The path to the tag board data file. This file contains additional information about the tags.<br>
				<input type="text" name="tag_dat" value="$TPVARS{'tag_dat'}" size="35">
				<br><br><b>Return URL</b>
				<br>The URL to the file that is linked to from messages and is displayed if Auto Redirect is on.<br>
				<input type="text" name="return_path" value="$TPVARS{'return_path'}" size="35">
				<br><br><b>IP Log Path</b>
				<br>The path to the file that is used to log IPs for the time limit.<br>
				<input type="text" name="ip_logfile" value="$TPVARS{'ip_logfile'}" size="35">
				<p align="center"><input type="submit" value=" Submit Settings ">
		</form>
EOF
	print_admin_footer();

	exit;

}

########

sub print_admin_page {

	print_admin_header('Admin Settings');
	print <<"EOF";
			<form method="POST"><input type="hidden" name="action" value="admin">
				<table border="0" cellpadding="0" cellspacing="0">
					<tr><td>Old Username:</td><td><input type="text" name="un" value="$TPVARS{'admin_uname'}"> (required)</tr>
					<tr><td>Old Password:</td><td><input type="password" name="pw"> (required)</tr>
					<tr><td>New Username:</td><td><input type="text" name="newun" value=""> (leave this blank if you do not want to change the username)</tr>
					<tr><td>New Password:</td><td><input type="password" name="newpw"> (leave this blank if you do not want to change the password)</tr>
				</table>
				<p align="center"><input type="submit" value=" Submit Changes ">
			</form>
EOF
	print_admin_footer();

	exit;

}

########

sub print_messages_page {

	print_admin_header('Messages');
	print <<"EOF";
			<form method="POST"><input type="hidden" name="action" value="messages">
				<big>Warning:</big> Do not use double quotes in these messages, use singles quotes or <b>&amp;quot;</b>. You may use HTML, but do not use the <b>input</b> tag. In the "successful tag" message you may refer to the return path by <b>RETURN_PATH</b>. If something goes wrong, click <a href="?action=msg_defaults">here</a> to restore the default messages.
				<p><b>Successful tag:</b><br>
				<input type="text" name="msg_tagged" value="$TPVARS{'msg_tagged'}" size="50">
				<br><br><b>Name or message is null:</b><br>
				<input type="text" name="msg_no_data" value="$TPVARS{'msg_no_data'}" size="50">
				<br><br><b>Tag exceeds maximum content size:</b><br>
				<input type="text" name="msg_long_tag" value="$TPVARS{'msg_long_tag'}" size="50">
				<br><br><b>HTML characters (&lt; or &gt;) in content:</b><br>
				<input type="text" name="msg_html_chars" value="$TPVARS{'msg_html_chars'}" size="50">
				<br><br><b>Invalid user password:</b><br>
				<input type="text" name="msg_inv_admin_pw" value="$TPVARS{'msg_inv_admin_pw'}" size="50">
				<br><br><b>Vulgarity:</b><br>
				<input type="text" name="msg_vulgarity" value="$TPVARS{'msg_vulgarity'}" size="50">
				<br><br><b>Maximum word size exceeded:</b><br>
				<input type="text" name="msg_word_max_chars" value="$TPVARS{'msg_word_max_chars'}" size="50">
				<br><br><b>Time limit exceeded:</b><br>
				<input type="text" name="msg_time_limit" value="$TPVARS{'msg_time_limit'}" size="50">
				<p align="center"><input type="submit" value=" Submit Messages ">
		</form>
EOF
	print_admin_footer();

	exit;

}

########

sub print_login_page {

	print_admin_header('Login');
	print <<"EOF";
			<p>Please enter your username and password for TagPro.
			<form method="POST"><input type="hidden" name="action" value="login">
				<table cellpadding="2" cellspacing="0" border="0" align="center">
					<tr><td>Username:</td><td><input type="text" name="un"></td></tr>
					<tr><td>Password:</td><td><input type="password" name="pw"></td></tr>
				</table>
				<p><div align="center"><input type="submit" value=" Login ">
			</form>
		</td></tr></table>
	</body>
</html>
EOF

	exit;

}

########

sub print_install_page {

	print_admin_header('Installation');
	print <<"EOF";
			<big>Welcome to TagPro!</big>
			<p><b><u>Step 1</u></b><br>Please choose an admin username and password for TagPro.
			<form method="POST">
				<table cellpadding="2" cellspacing="0" border="0" align="center">
					<tr><td>Username:</td><td><input type="text" name="un"></td></tr>
					<tr><td>Password:</td><td><input type="password" name="pw"></td></tr>
				</table>
				<p><b><u>Step 2</u></b><br>It is important that TagPro's data file ($VARFILE) is not visible over the Web. Click <b><a href="$VARFILE" target="_blank">here</a></b> to try and view the file. (A new window will open.)
				<br><br>If you can view the file and you are using a Unix server, CHMOD $VARFILE 660 before continuing. You may also change the path or filename to something that would not be guessed. Details on how to change the filename can be found in the readme.txt.
				<p><br>After you have completed steps one and two, click the button below to finish the installation.
				<p><div align="center"><input type="submit" value=" INSTALL ">
			</form>
		</td></tr></table>
	</body>
</html>
EOF

	exit;

}

#############
## ACTIONS ######################################################
#############

sub do_settings {

	$TPVARS{'max_tags'} = $q->param('max_tags');
	$TPVARS{'separator'} = $q->param('separator');
	$TPVARS{'max_content_size'} = $q->param('max_content_size');
	$TPVARS{'word_max_chars'} = $q->param('word_max_chars');
	$TPVARS{'time_limit'} = $q->param('time_limit');
	$TPVARS{'auto_redirect'} = $q->param('auto_redirect');
	$TPVARS{'bad_words'} = $q->param('bad_words');
	$TPVARS{'tag_path'} = $q->param('tag_path');
	$TPVARS{'tag_dat'} = $q->param('tag_dat');
	$TPVARS{'return_path'} = $q->param('return_path');
	$TPVARS{'ip_logfile'} = $q->param('ip_logfile');

	save_vars();
	message('Settings Saved', 'The settings have been saved.');

}

########

sub do_tags {

	my $num = $q->param('num');
	my @tags = ();
	my $cur = 0;
	my @new_tags;
	my @board;
	my ($name, $url, $msg, $content, $i);

	open IN, $TPVARS{'tag_dat'} or error_msg('Cannot open the tag board data file.');
	@new_tags = <IN>;
	close IN;

	if($#new_tags ne $num) {
		message('The tag board data file has changed while you were modifying the tags. TagPro is lazy and cannot save changes. Please try again.');
	}

	for($i = 0; $i <= $num; $i++) {

		if($q->param("keep$i")) {

			$name =	$q->param("name$i");
			$url = $q->param("url$i");
			$msg = $q->param("msg$i");

			unshift @tags, (join('<>',($cur++, $q->param("time$i"), $q->param("ip$i"), $name, $url, $msg)) . "\n");

			$name = "<a href=\"$url\" target=\"blank\">$name</a>" if($url);
			$content = "$name$TPVARS{'separator'}$msg<br>\n";

			unshift @board, $content;

		}
	}

	open OUT, ">$TPVARS{'tag_dat'}" or error_msg('Cannot open the tag board data file.');
	print OUT @tags;
	close OUT;

	open TAG, ">$TPVARS{'tag_path'}" or error_msg('Cannot open the tag board file.');
	print TAG @board;
	close TAG;

	message('Modify Tags', 'The tag board has been saved.');

}

########

sub do_admin {

	my $un = $q->param('un');
	my $pw = $q->param('pw');
	   
	if($un eq $TPVARS{'admin_uname'} && $pw eq $TPVARS{'admin_pword'}) {

		my $newun = $q->param('newun');
		my $newpw = $q->param('newpw');

		if($newun || $newpw) {

			if($newun) {
				$TPVARS{'admin_uname'} = $newun;
				$un = $newun;
			}
			if($newpw) {
				$TPVARS{'admin_pword'} = $newpw;
				$pw = $newpw;
			}

			save_vars();
			SetCookies('uname',$un,'pword',$pw);
			message('Admin Settings', 'The username/password has been changed.');

		} else {
			message('Admin Settings', 'Nothing has been changed.');
		}
	   
	} else {
		error_msg('Invalid username/password.');
	}

}

########

sub do_messages {

	$TPVARS{'msg_tagged'} = $q->param('msg_tagged');
	$TPVARS{'msg_no_data'} = $q->param('msg_no_data');
	$TPVARS{'msg_long_tag'} = $q->param('msg_long_tag');
	$TPVARS{'msg_html_chars'} = $q->param('msg_html_chars');
	$TPVARS{'msg_inv_admin_pw'} = $q->param('msg_inv_admin_pw');
	$TPVARS{'msg_vulgarity'} = $q->param('msg_vulgarity');
	$TPVARS{'msg_word_max_chars'} = $q->param('msg_word_max_chars');
	$TPVARS{'msg_time_limit'} = $q->param('msg_time_limit');

	save_vars();
	message('Messages Saved', 'The messages have been saved.');

}

########

sub do_msg_defaults() {

	$TPVARS{'msg_tagged'} = "<p align=\'center\'><b>Done!</b><br>Click <a href=\'RETURN_PATH\'>here</a> to view your post.";
	$TPVARS{'msg_no_data'} = 'No data.';
	$TPVARS{'msg_long_tag'} = 'Too much data.';
	$TPVARS{'msg_html_chars'} = 'Invalid character: &lt; or &gt;';
	$TPVARS{'msg_inv_admin_pw'} = 'Invalid user password.';
	$TPVARS{'msg_vulgarity'} = 'No vulgarity.';
	$TPVARS{'msg_word_max_chars'} = 'This tag board is slightly illiterate. Big words are shunned upon.';
	$TPVARS{'msg_time_limit'} = 'Posting time limit exceeded.';

	save_vars();
	print_messages_page();

}

###############################
## ERROR & MESSAGE FUNCTIONS ####################################
###############################

sub error_msg {

	my $m = shift;
	print_admin_header('Error');
	print <<"EOF";
			<b>Error</b>: $m
			<p align="center"><input type="button" value="	OK	 " onclick="history.go(-1);">
		</td></tr></table>
	</body>
</html>
EOF

	exit;

}

########

sub message {

	my ($title, $message) = @_;
	print_admin_header($title);
	print "\t\t\t$message\n";
	print_admin_footer();
	exit;

}

######################
## COOKIE FUNCTIONS #############################################
######################
# These cookie functions are slightly modified versions of 
# those found in NewsPro. (http://amphibian.gagames.com/newspro/)

sub GetCookies {

	my $cookie; my $value; my $char;
	my @Cookie_Decode_Chars = ('\+', '\%3A\%3A', '\%26', '\%3D', '\%2C', '\%3B', '\%2B', '\%25');
	my %Cookie_Decode_Chars = ('\+', ' ', '\%3A\%3A', '::', '\%26', '&', '\%3D', '=', '\%2C', ',', '\%3B', ';', '\%2B', '+', '\%25', '%');

	if ($ENV{'HTTP_COOKIE'}) {
		foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
			($cookie,$value) = split(/=/);
			foreach $char (@Cookie_Decode_Chars) {
				$cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
				$value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
			}
			$Cookies{$cookie} = $value;
		}
	}

}

########

sub SetCookies {

	my @cookies = @_;
	my $cookie; my $value; my $char;
	my $exptime;
	my @Cookie_Encode_Chars = ('\%', '\+', '\;', '\,', '\=', '\&', '\:\:', '\s');
	my %Cookie_Encode_Chars = ('\%', '%25', '\+', '%2B', '\;', '%3B', '\,', '%2C', '\=', '%3D', '\&', '%26', '\:\:', '%3A%3A', '\s', '+');

	print "Content-type: text/html\n";

	while (($cookie, $value) = @cookies) {

		foreach $char (@Cookie_Encode_Chars) {
			$cookie =~ s/$char/$Cookie_Encode_Chars{$char}/g;
			$value =~ s/$char/$Cookie_Encode_Chars{$char}/g;
		}
   
		print "Set-Cookie: $cookie=$value;";

		$exptime = DoGMTTime(time + $cookieExpLength);
		print " expires=$exptime;\n";

		shift(@cookies); shift(@cookies);

	}

	print "\n";
	$header_printed = 1;

}

########

sub ClearCookies {

	print "Content-type: text/html\n";
	print "Set-Cookie: uname=x; expires=Thu, 03-Feb-2000 00:00:00 GMT;\n";
	print "Set-Cookie: pword=x; expires=Thu, 03-Feb-2000 00:00:00 GMT;\n\n";
	$header_printed = 1;

}

########

sub DoGMTTime {

	my $thetime = shift;
	my $thedate;
	my ($Second,$Minute,$Hour,$Month_Day, $Month,$Year,$Week_Day,$IsDST) = (localtime($thetime))[0,1,2,3,4,5,6,8]; 
	$Month_Day = "0$Month_Day" if ($Month_Day < 10);
	$Year = $Year + 1900;
	$thedate = "$Abbrev_Week_Days[$Week_Day], $Month_Day-$Abbrev_Months[$Month]-$Year 00:00:00 GMT";
	return $thedate;

}

#################################################################
